package com.plannaplan.responses.mappers;

import java.util.List;
import java.util.Objects;
import java.util.stream.Collectors;

import com.plannaplan.entities.Groups;
import com.plannaplan.responses.models.DefaultGroupResponse;
import com.plannaplan.responses.models.WithCapacityGroupResponse;

public class GroupsMappers {
    public static List<DefaultGroupResponse> mapToDefaultResponse(List<Groups> groups) {
        return groups.stream().filter(Objects::nonNull).map(DefaultGroupResponse::new).collect(Collectors.toList());
    }

    public static List<WithCapacityGroupResponse> mapToCapacityResponse(List<Groups> groups) {
        return groups.stream().filter(Objects::nonNull).map(WithCapacityGroupResponse::new)
                .collect(Collectors.toList());
    }
}
